package com.spiderlee.spider_lee

import android.util.Log
import com.spiderlee.spider_lee.SpiderLeePlugin.Companion.Spider_PLUGIN_TAG

//import com.spiderlee.spider_lee.SpiderLeePlugin.Companion.Spider_PLUGIN_TAG
import io.flutter.plugin.common.EventChannel
import java.io.Serializable

/**
 * StreamHandler to listen to conference events and broadcast it back to Flutter
 */
class SpiderLeeEventStreamHandler private constructor(): EventChannel.StreamHandler, Serializable {
    companion object {
        val instance = SpiderLeeEventStreamHandler()
    }

    private var eventSink: EventChannel.EventSink? = null

    override fun onListen(arguments: Any?, eventSink: EventChannel.EventSink?) {
        Log.d(Spider_PLUGIN_TAG, "SpiderLeeEventStreamHandler.onListen")
        this.eventSink = eventSink
    }

    override fun onCancel(arguments: Any?) {
        Log.d(Spider_PLUGIN_TAG, "SpiderLeeEventStreamHandler.onCancel")
        eventSink = null
    }

    fun onConferenceWillJoin(data: MutableMap<String, Any>?) {
        Log.d(Spider_PLUGIN_TAG, "SpiderLeeEventStreamHandler.onConferenceWillJoin")
        data?.put("event", "onConferenceWillJoin")
        eventSink?.success(data)
    }

    fun onConferenceJoined(data: MutableMap<String, Any>?) {
        Log.d(Spider_PLUGIN_TAG, "SpiderLeeEventStreamHandler.onConferenceJoined")
        data?.put("event", "onConferenceJoined")
        eventSink?.success(data)
    }

    fun onConferenceTerminated(data: MutableMap<String, Any>?) {
        Log.d(Spider_PLUGIN_TAG, "SpiderLeeEventStreamHandler.onConferenceTerminated")
        data?.put("event", "onConferenceTerminated")
        eventSink?.success(data)
    }

}